//+------------------------------------------------------------------+
//|                                                    Supernova.mq4 |
//+------------------------------------------------------------------+

extern double Lots=0.10;
extern int StopLoss=0;     //if set to 0 then it is disabled
extern int TakeProfit=0;   //if set to 0 then it is disabled
extern int Trailing_Stop=0;  //if set to 0 then it is disabled

extern bool Filters_ON=true;
extern bool StopAndReverse=true;

extern int QQE_SF = 1;

extern int DMI_Smooth   = 14;
extern bool DMI_Hide_DI_Plus  = False;
extern bool DMI_Hide_DI_Minus = False;
extern bool DMI_Hide_DX   = true;
extern bool DMI_Hide_ADX  = true;
extern bool DMI_Hide_ADXR = true;

extern int MomPeriod=10;

extern int Slippage=3;
extern int Magic_Number=100;

extern int Trade_Bar=1;
datetime last_t=0;
string com="Ben Rose EA";

int init(){return(0);}
int deinit(){return(0);}
int start()
  {
   int i=0;
   double ask,bid;
   double SL=0,TP=0;

   bool up=false;
   bool dn=false;

   double qqe0_0=iCustom(Symbol(),0,"QQE",QQE_SF,0,Trade_Bar);
   double qqe0_1=iCustom(Symbol(),0,"QQE",QQE_SF,0,Trade_Bar+1);
   double qqe1_0=iCustom(Symbol(),0,"QQE",QQE_SF,1,Trade_Bar);
   double qqe1_1=iCustom(Symbol(),0,"QQE",QQE_SF,1,Trade_Bar+1);
   
   double mom_0=iCustom(Symbol(),0,"MomentumVT",MomPeriod,0,Trade_Bar);
   double mom_1=iCustom(Symbol(),0,"MomentumVT",MomPeriod,0,Trade_Bar+1);
   
   double dmi0_0=iCustom(Symbol(),0,"dmi",DMI_Smooth,DMI_Hide_DI_Plus,DMI_Hide_DI_Minus,DMI_Hide_DX,DMI_Hide_ADX,DMI_Hide_ADXR,0,Trade_Bar);
   double dmi0_1=iCustom(Symbol(),0,"dmi",DMI_Smooth,DMI_Hide_DI_Plus,DMI_Hide_DI_Minus,DMI_Hide_DX,DMI_Hide_ADX,DMI_Hide_ADXR,0,Trade_Bar+1);
   double dmi1_0=iCustom(Symbol(),0,"dmi",DMI_Smooth,DMI_Hide_DI_Plus,DMI_Hide_DI_Minus,DMI_Hide_DX,DMI_Hide_ADX,DMI_Hide_ADXR,1,Trade_Bar);
   double dmi1_1=iCustom(Symbol(),0,"dmi",DMI_Smooth,DMI_Hide_DI_Plus,DMI_Hide_DI_Minus,DMI_Hide_DX,DMI_Hide_ADX,DMI_Hide_ADXR,1,Trade_Bar+1);
   
   if (Filters_ON) {
      if ((qqe0_0>qqe1_0 && qqe0_1<=qqe1_1 && dmi0_0>dmi1_0 && mom_0>0) || 
         (qqe0_0>qqe1_0 && dmi0_0>dmi1_0 && dmi0_1<=dmi1_1 && mom_0>0)  ||
         (qqe0_0>qqe1_0 && dmi0_0>dmi1_0 && mom_0>0 && mom_1<0)){
         up=true;
         dn=false;
      }
      if ((qqe0_0<qqe1_0 && qqe0_1>=qqe1_1 && dmi0_0<dmi1_0 && mom_0<0) || 
         (qqe0_0<qqe1_0 && dmi0_0<dmi1_0 && dmi0_1>=dmi1_1 && mom_0<0)  ||
         (qqe0_0<qqe1_0 && dmi0_0<dmi1_0 && mom_0<0 && mom_1>0)){
         up=false;
         dn=true;      
      }      
   }else{
      if (qqe0_0>qqe1_0 && qqe0_1<=qqe1_1){
         up=true;
         dn=false;
      }
      if (qqe0_0<qqe1_0 && qqe0_1>=qqe1_1){
         up=false;
         dn=true;      
      }
   }  
   if (TotalOrders(Magic_Number)==0 && Time[0]>last_t){
      if (up ){
         RefreshRates();
         ask=MarketInfo(Symbol(),MODE_ASK);
         if (StopLoss>0) {SL=NormalizeDouble(ask-StopLoss*Point,Digits);}else{SL=0;}
         if (TakeProfit>0) {TP=NormalizeDouble(ask+TakeProfit*Point,Digits);}else{TP=0;}
         if (OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(ask,Digits),Slippage,SL,TP,com,Magic_Number,0,Blue)==-1) {
               i=GetLastError();
               if (i!=1 && i!=0) Print("Buy Error :"+error(i)+" at "+Symbol()+" "+Period());                 
         }else{
            last_t=Time[0];
            return(0);
         }
      }
      if (dn ){
         RefreshRates();
         bid=MarketInfo(Symbol(),MODE_BID);
         if (StopLoss>0) {SL=NormalizeDouble(bid+StopLoss*Point,Digits);}else{SL=0;}
         if (TakeProfit>0) {TP=NormalizeDouble(bid-TakeProfit*Point,Digits);}else{TP=0;}
         if (OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(bid,Digits),Slippage,SL,TP,com,Magic_Number,0,Red)==-1) {
               i=GetLastError();
               if (i!=1 && i!=0) Print("Sell Error :"+error(i)+" at "+Symbol()+" "+Period());                 
         }else{
            last_t=Time[0];
            return(0);
         }
      }         
   }
   
   if (TotalOrders(Magic_Number)>0){
      if (Trailing_Stop>0) tr(Magic_Number,Trailing_Stop);
      for (int o=0;i<OrdersTotal();o++){
         OrderSelect(o,SELECT_BY_POS);
         if (OrderMagicNumber()==Magic_Number) break;         
      }
      if (OrderType()==OP_BUY && dn && StopAndReverse){
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,Pink);
      }
      if (OrderType()==OP_SELL && up && StopAndReverse){
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,Pink);
      }
   }
   
   return(0);   
  }

int TotalOrders(int magic){
   int rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic){
         rez++;
      }
   }   
   return(rez);
} 


void tr(int magic,int triling_i){  
  for (int k=0;k<OrdersTotal();k++){
    OrderSelect(k,SELECT_BY_POS);
    if (OrderMagicNumber()==magic){        
      if (OrderType()==OP_BUY && NormalizeDouble(Ask-OrderOpenPrice(),Digits)>=triling_i*Point && OrderStopLoss()<NormalizeDouble(Ask-triling_i*Point,Digits)) {
         if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask-triling_i*Point,Digits),OrderTakeProfit(),0,Blue)){
            Print("Trailing stop error Buy :"+error(GetLastError()));
         }    
      }
      if (OrderType()==OP_SELL && NormalizeDouble(Bid+triling_i*Point,Digits)<=OrderOpenPrice() && (OrderStopLoss()>NormalizeDouble(Bid+triling_i*Point,Digits) || OrderStopLoss()==0)) {
         if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid+triling_i*Point,Digits),OrderTakeProfit(),0,Red)){
            Print("Trailing stop error Sell :"+error(GetLastError()));  
         }
      }
    }
  }
}

string error(int err){
switch (err){
 case 0 :return("No error returned.");
 case 1 :return("No error returned, but the result is unknown. ");
 case 2 :return("Common error. ");
 case 3 :return("Invalid trade parameters. ");
 case 4 :return("Trade server is busy. ");
 case 5 :return("Old version of the client terminal. ");
 case 6 :return("No connection with trade server. ");
 case 7 :return("Not enough rights. ");
 case 8 :return("Too frequent requests."); 
 case 9 :return("Malfunctional trade operation. ");
 case 64 :return("Account disabled. ");
 case 65 :return("Invalid account. ");
 case 128 :return("Trade timeout. ");
 case 129 :return("Invalid price. ");
 case 130 :return("Invalid stops. ");
 case 131 :return("Invalid trade volume. ");
 case 132 :return("Market is closed. ");
 case 133 :return("Trade is disabled. ");
 case 134 :return("Not enough money. ");
 case 135 :return("Price changed. ");
 case 136 :return("Off quotes. ");
 case 137 :return("Broker is busy."); 
 case 138 :return("Requote. ");
 case 139 :return("Order is locked. ");
 case 140 :return("Long positions only allowed. ");
 case 141 :return("Too many requests. ");
 case 145 :return("Modification denied because order too close to market. ");
 case 146 :return("Trade context is busy. ");
 case 147 :return("Expirations are denied by broker. ");
 case 148 :return("The amount of open and pending orders has reached the limit set by the broker. ");
 case 4000 :return("No error. ");
 case 4001 :return("Wrong function pointer. ");
 case 4002 :return("Array index is out of range. ");
 case 4003 :return("No memory for function call stack. ");
 case 4004 :return("Recursive stack overflow. ");
 case 4005 :return("Not enough stack for parameter. ");
 case 4006 :return("No memory for parameter string. ");
 case 4007 :return("No memory for temp string. ");
 case 4008 :return("Not initialized string. ");
 case 4009 :return("Not initialized string in array. ");
 case 4010 :return("No memory for array string. ");
 case 4011 :return("Too long string. ");
 case 4012 :return("Remainder from zero divide. ");
 case 4013 :return("Zero divide. ");
 case 4014 :return("Unknown command. ");
 case 4015 :return("Wrong jump (never generated error). ");
 case 4016 :return("Not initialized array. ");
 case 4017 :return("DLL calls are not allowed. ");
 case 4018 :return("Cannot load library. ");
 case 4019 :return("Cannot call function. ");
 case 4020 :return("Expert function calls are not allowed. ");
 case 4021 :return("Not enough memory for temp string returned from function. ");
 case 4022 :return("System is busy (never generated error). ");
 case 4050 :return("Invalid function parameters count. ");
 case 4051 :return("Invalid function parameter value. ");
 case 4052 :return("String function internal error. ");
 case 4053 :return("Some array error. ");
 case 4054 :return("Incorrect series array using. ");
 case 4055 :return("Custom indicator error. ");
 case 4056 :return("Arrays are incompatible. ");
 case 4057 :return("Global variables processing error. ");
 case 4058 :return("Global variable not found. ");
 case 4059 :return("Function is not allowed in testing mode. ");
 case 4060 :return("Function is not confirmed. ");
 case 4061 :return("Send mail error. ");
 case 4062 :return("String parameter expected. ");
 case 4063 :return("Integer parameter expected. ");
 case 4064 :return("Double parameter expected. ");
 case 4065 :return("Array as parameter expected. ");
 case 4066 :return("Requested history data in updating state. ");
 case 4067 :return("Some error in trading function. ");
 case 4099 :return("End of file. ");
 case 4100 :return("Some file error."); 
 case 4101 :return("Wrong file name. ");
 case 4102 :return("Too many opened files. ");
 case 4103 :return("Cannot open file. ");
 case 4104 :return("Incompatible access to a file. ");
 case 4105 :return("No order selected. ");
 case 4106 :return("Unknown symbol. ");
 case 4107 :return("Invalid price. ");
 case 4108 :return("Invalid ticket. ");
 case 4109 :return("Trade is not allowed. ");
 case 4110 :return("Longs are not allowed. ");
 case 4111 :return("Shorts are not allowed. ");
 case 4200 :return("Object exists already. ");
 case 4201 :return("Unknown object property. ");
 case 4202 :return("Object does not exist. ");
 case 4203 :return("Unknown object type. ");
 case 4204 :return("No object name. ");
 case 4205 :return("Object coordinates error. ");
 case 4206 :return("No specified subwindow. ");
 case 4207 :return("Some error in object function. ");
 default: return("Unknown error:"+err);
}
}

/*For the EA I take trades on short term trades when QQE (smoothing set to 1)
crosses the rsislow line. If the momentum and dmi indicator agree. But I
also wish to trade the qqe cross on longer timeframes so would want an
option in the ea like "filters on" and "filters off" as the longer
timeframes do not require the additional indicators but only the qqe cross.

So if filters are "on" ea would only take a long if qqe cross up, dmi
(directional movement idex) has blue on top of red and momentum has crossed
o line upwards opposite for shorts. If filters are "off" ea will place
trades on the candle after the QQE crossed.

Would need to have hard stop and trailing stop as well as tp options.I also
need magic number function.

I would also like the ea to have stop and reverse function if I choose it.
So it will buy then when sell signals appears it will close buy position and
reverse trade and so on until I disable ea from trading..
Please advise if you can help.
*/

